#pragma once

#include <cstdint>
#include <base/ovlibrary/ovlibrary.h>

#include <cstdint>
#include <cstdint>

class VP8Parser
{
public:
	static bool IsValid(const std::uint8_t *data, size_t data_length);
	static bool Parse(const std::uint8_t *data, size_t data_length, VP8Parser &parser);

	bool IsKeyFrame();
	uint16_t GetWidth();
	uint16_t GetHeight();
	std::uint8_t GetHorizontalScale();
	std::uint8_t GetVerticalScale();

	ov::String GetInfoString();

public:
	bool _key_frame;
	std::uint8_t _version;
	std::uint8_t _show_frame;
	uint32_t _first_part_size;

	uint16_t _width;
	std::uint8_t _horizontal_scale;

	uint16_t _height;
	std::uint8_t _vertical_scale;
};