//==============================================================================
//
//  OvenMediaEngine
//
//  Created by Getroot
//  Copyright (c) 2022 AirenSoft. All rights reserved.
//
//==============================================================================
#pragma once

#include <cstdint>
#include <base/ovlibrary/ovlibrary.h>
#include <cstdint>
#include "data_structure.h"
#include <cstdint>
#include "table_connector.h"

namespace http
{
	// https://www.rfc-editor.org/rfc/rfc7541.html
	namespace hpack
	{
		class Decoder
		{
		public:
			bool Decode(const std::shared_ptr<const ov::Data> &data, std::vector<HeaderField> &header_fields);

		private:
			bool DecodeIndexedHeaderField(const std::shared_ptr<BitReader> &reader, std::vector<HeaderField> &header_fields);
			bool DecodeLiteralHeaderFieldWithIndexing(const std::shared_ptr<BitReader> &reader, std::vector<HeaderField> &header_fields);
			bool DecodeLiteralHeaderFieldWithoutIndexing(const std::shared_ptr<BitReader> &reader, std::vector<HeaderField> &header_fields);
			bool DecodeLiteralHeaderFieldNeverIndexed(const std::shared_ptr<BitReader> &reader, std::vector<HeaderField> &header_fields);

			bool DecodeDynamicTableSizeUpdate(const std::shared_ptr<BitReader> &reader);

			bool ReadLiteralHeaderField(std::uint8_t index_bits, const std::shared_ptr<BitReader> &reader, HeaderField &header_field);

			// Unsigned Little Endian Base 128
			bool ReadULEB128(const std::shared_ptr<BitReader> &reader, std::uint64_t &value);
			bool ReadString(const std::shared_ptr<BitReader> &reader, ov::String &value);

			TableConnector	_table_connector;
		};
	} // namespace hpack
} // namespace http