//==============================================================================
//
//  RtmpProvider
//
//  Created by Jaejong Bong
//  Copyright (c) 2018 AirenSoft. All rights reserved.
//
//==============================================================================

#pragma once

#include <cstdint>
#include "rtmp_define.h"


//===============================================================================================
// RtmpHandshake
//===============================================================================================
class RtmpHandshake
{
public:
	RtmpHandshake() = default;
	~RtmpHandshake() = default;

public:
	static	bool	MakeS1(std::uint8_t *sig);
	static	bool	MakeC1(std::uint8_t *sig);
	
	static	bool	MakeS2(const std::uint8_t *client_sig, std::uint8_t *sig);
    static	bool	MakeC2(std::uint8_t *client_sig, std::uint8_t *sig);

private:
	static	int		GetDigestOffset1(const std::uint8_t *handshake);
	static	int		GetDigestOffset2(const std::uint8_t *handshake);
	static	void	HmacSha256(const std::uint8_t *message, int message_size, std::uint8_t *key, int key_size, std::uint8_t *digest);
	static	void	CalculateDigest(int digest_pos, const std::uint8_t *message, std::uint8_t *key, int key_size, std::uint8_t *digest);
	static	bool	VerifyDigest(int digest_pos, const std::uint8_t *message, std::uint8_t *key, int key_size);
};

